//---------------------------------------------------------------------
//  Algorithmic Conjurings @ http://www.coyotegulch.com
//
//  command_line.cpp (libcoyote)
//---------------------------------------------------------------------
//
//  COPYRIGHT NOTICE, DISCLAIMER, and LICENSE:
//
//  If you modify this file, you may insert additional notices
//  immediately following this sentence.
//  
//  Copyright 2000, 2002, 2003 Scott Robert Ladd.
//  All rights reserved, except as noted herein.
//
//  This computer program a_source file is supplied "AS IS". Scott Robert
//  Ladd (hereinafter referred to as "Author") disclaims all warranties,
//  expressed or implied, including, without limitation, the warranties
//  of merchantability and of fitness for any purpose. The Author
//  assumes no liability for direct, indirect, incidental, special,
//  exemplary, or consequential damages, which may result from the use
//  of this software, even if advised of the possibility of such damage.
//  
//  The Author hereby grants anyone permission to use, copy, modify, and
//  distribute this a_source code, or portions hereof, for any purpose,
//  without fee, subject to the following restrictions:
//  
//      1. The origin of this a_source code must not be misrepresented.
//  
//      2. Altered versions must be plainly marked as such and must not
//         be misrepresented as being the original a_source.
//  
//      3. This Copyright notice may not be removed or altered from any
//         a_source or altered a_source distribution.
//  
//  The Author specifically permits (without fee) and encourages the use
//  of this a_source code for entertainment, education, or decoration. If
//  you use this a_source code in a product, acknowledgment is not required
//  but would be appreciated.
//  
//  Acknowledgement:
//      This license is based on the wonderful simple license that
//      accompanies libpng.
//
//-----------------------------------------------------------------------
//  For more information on this software package, please visit
//  Scott's web site, Coyote Gulch Productions, at:
//
//      http://www.coyotegulch.com
//-----------------------------------------------------------------------

#include "libcoyote/command_line.h"
using namespace libcoyote;

command_line::command_line(int argc, char * argv[])
  : m_options(),
    m_inputs()
{
    bool option_active = false;
    vector<option>::iterator active_option;
    
    for (int i = 1; i < argc; ++i)
    {
        // is it an option?
        if ((strlen(argv[i]) > 1) && (argv[i][0] == '-'))
        {
            m_options.push_back(option(string(&argv[i][1])));
            active_option = m_options.end();
            --active_option;
            option_active = true;
        }
        else
        {
            if (option_active)
                active_option->m_value = string(argv[i]);
            else
                m_inputs.push_back(string(argv[i]));
                
            option_active = false;
        }
    }
}

