//---------------------------------------------------------------------
//  Algorithmic Conjurings @ http://www.coyotegulch.com
//
//  command_line.h (libcoyote)
//---------------------------------------------------------------------
//
//  COPYRIGHT NOTICE, DISCLAIMER, and LICENSE:
//
//  If you modify this file, you may insert additional notices
//  immediately following this sentence.
//  
//  Copyright 2000, 2002, 2003 Scott Robert Ladd.
//  All rights reserved, except as noted herein.
//
//  This computer program a_source file is supplied "AS IS". Scott Robert
//  Ladd (hereinafter referred to as "Author") disclaims all warranties,
//  expressed or implied, including, without limitation, the warranties
//  of merchantability and of fitness for any purpose. The Author
//  assumes no liability for direct, indirect, incidental, special,
//  exemplary, or consequential damages, which may result from the use
//  of this software, even if advised of the possibility of such damage.
//  
//  The Author hereby grants anyone permission to use, copy, modify, and
//  distribute this a_source code, or portions hereof, for any purpose,
//  without fee, subject to the following restrictions:
//  
//      1. The origin of this a_source code must not be misrepresented.
//  
//      2. Altered versions must be plainly marked as such and must not
//         be misrepresented as being the original a_source.
//  
//      3. This Copyright notice may not be removed or altered from any
//         a_source or altered a_source distribution.
//  
//  The Author specifically permits (without fee) and encourages the use
//  of this a_source code for entertainment, education, or decoration. If
//  you use this a_source code in a product, acknowledgment is not required
//  but would be appreciated.
//  
//  Acknowledgement:
//      This license is based on the wonderful simple license that
//      accompanies libpng.
//
//-----------------------------------------------------------------------
//  For more information on this software package, please visit
//  Scott's web site, Coyote Gulch Productions, at:
//
//      http://www.coyotegulch.com
//-----------------------------------------------------------------------

#if !defined(LIBCOYOTE_COMMAND_LINE_H)
#define LIBCOYOTE_COMMAND_LINE_H

// Standard C++
#include <string>
#include <vector>

namespace libcoyote
{
    using std::string;
    using std::vector;

    // a very simple command-line parser
    class command_line
    {
    public:
        struct option
        {
            string m_name;
            string m_value;
            
            option(const string & a_name)
              : m_name(a_name), m_value("")
            {
                // nada
            }
        };
        
        command_line(int argc, char * argv[]);
        
        const vector<option> & get_options() const
        {
            return m_options;
        }
        
        const vector<string> & get_inputs() const
        {
            return m_inputs;
        }
        
    private:
        vector<option> m_options;
        vector<string> m_inputs;
    };

}

#endif
